 Option Explicit
 Sub raketenankunftszeit4()
 ' Dieses Programm berechnet die Ankunftszeit einer Rakete.
 '   Eingaben:   Abflugzeit in Monaten, Tagen, Stunden, Minuten und Sekunden
 '               Ankunftszeit in Monaten, Tagen, Stunden, Minuten und Sekunden
 '   Ausgabe:    Flugdauer in Tagen, Stunden, Minuten und Sekunden
 ' berprfung der Eingaben
 ' Prozeduren und Funktionen
 ' Dateiname raketen5
 
 Dim AbflugMonat As Long
 Dim AbflugTage As Long
 Dim AbflugStunden As Long
 Dim AbflugMinuten As Long
 Dim AbflugSekunden As Long
 Dim LandungMonat As Long
 Dim LandungTage As Long
 Dim LandungStunden As Long
 Dim LandungMinuten As Long
 Dim LandungSekunden As Long
     
 Dim FlugzeitTage As Long
 Dim FlugzeitStunden As Long
 Dim FlugzeitMinuten As Long
 Dim FlugzeitSekunden As Long
 Dim AbflugInSekunden As Long
 Dim LandungInSekunden As Long
 Dim FlugdauerInSekunden As Long
 Dim eingabe As String
 
 'Initialisierung
 
 'Ausgabe der Bedienungsanleitung
     
     MsgBox ("Bitte geben Sie die Startzeit und die Landezeit der Rakete " & Chr$(13) & _
         "in Monaten, Tagen, Stunden, Minuten und Sekunden  an. " & Chr$(13) & _
         "Auch die Ausgabe erfolgt in Tagen, Stunden, Minuten und Sekunden.")
              
 'Einlesen der Benutzereingaben
     
     eingabe = InputBox("Geben Sie nun den Monat der Abflugzeit ein!")
     Lies_restliche_und_ueberpruefe_alle_Benutzereingaben eingabe, _
         AbflugMonat, AbflugTage, AbflugStunden, AbflugMinuten, AbflugSekunden, _
         LandungMonat, LandungTage, LandungStunden, LandungMinuten, LandungSekunden
 
 ' Rechne Startzeit und Landezeit in Sekunden um
     
     AbflugInSekunden = berechnete_Tage(AbflugMonat, AbflugTage) * 24 * 3600 + _
         AbflugStunden * 3600 + AbflugMinuten * 60 + AbflugSekunden
 
     LandungInSekunden = berechnete_Tage(LandungMonat, LandungTage) * 24 * 3600 + _
         LandungStunden * 3600 + LandungMinuten * 60 + LandungSekunden
     
 ' Berechne die Flugdauer
     
     FlugdauerInSekunden = LandungInSekunden - AbflugInSekunden
     If (FlugdauerInSekunden < 0) Then
         MsgBox ("Der Landezeitpunkt liegt vor dem Startzeitpunkt!")
         Exit Sub
     End If
     
	berechneFlugzeit(FlugdauerInSekunden, FlugzeitStunden, _
 						FlugzeitTage, FlugzeitStunden, FlugzeitMinuten, _
 						FlugzeitSekunden) 
     
 'Gib die Flugdauer am Bildschirm aus
     
     If (FlugzeitTage > 0) Then
         MsgBox ("Die Flugzeit der Rakete ist: " & FlugzeitTage & _
         " Tag(e) " & FlugzeitStunden & " Stunde(n) " & _
         FlugzeitMinuten & " Minute(n) " & FlugzeitSekunden _
         & " Sekunde(n).")
     Else
         MsgBox ("Die Flugzeit der Rakete ist: " & FlugzeitStunden & ":" & _
             FlugzeitMinuten & ":" & FlugzeitSekunden)
         End If
 End Sub
 
 Sub Lies_restliche_und_ueberpruefe_alle_Benutzereingaben(ByVal eingabe _
                     As String, AbflugMonat As Long, _
                     AbflugTage As Long, _
                     AbflugStunden As Long, _
                     AbflugMinuten As Long, _
                     AbflugSekunden As Long, _
                     LandungMonat As Long, _
                     LandungTage As Long, _
                     LandungStunden As Long, _
                     LandungMinuten As Long, _
                     LandungSekunden As Long)
                                             
     if Not wandle_in_Long_um (eingabe, AbflugMonat) then exit sub
                 
     eingabe = InputBox("Geben Sie nun die Tage der Abflugzeit ein!")
     if Not wandle_in_Long_um(eingabe, AbflugTage) then exit sub
 
     eingabe = InputBox("Geben Sie nun die Stunde der Abflugzeit ein!")
     if Not wandle_in_Long_um (eingabe, AbflugStunden) then exit sub
 
     eingabe = InputBox("Geben Sie nun die Minuten der Abflugzeit ein!")
     if Not wandle_in_Long_um (eingabe, AbflugMinuten) then exit sub
 
     eingabe = InputBox("Geben Sie nun die Sekunden der Abflugzeit ein!")
     if Not wandle_in_Long_um (eingabe, AbflugSekunden) then exit sub
 
     eingabe = InputBox("Geben Sie nun den Monat der Landungzeit ein!")
     if Not wandle_in_Long_um (eingabe, LandungMonat) then exit sub
                 
     eingabe = InputBox("Geben Sie nun die Tage der Landungzeit ein!")
     if Not wandle_in_Long_um (eingabe, LandungTage) then exit sub
 
     eingabe = InputBox("Geben Sie nun die Stunde der Landungzeit ein!")
     if Not wandle_in_Long_um (eingabe, LandungStunden) then exit sub
 
     eingabe = InputBox("Geben Sie nun die Minuten der Landungzeit ein!")
     if Not wandle_in_Long_um (eingabe, LandungMinuten) then exit sub
 
     eingabe = InputBox("Geben Sie nun die Sekunden der Landungzeit ein!")
     if Not wandle_in_Long_um (eingabe, LandungSekunden) then exit sub
 End Sub
 
 Function wandle_in_Long_um(ByVal eingabe As String, rueckgabe As Long) _
 				As Boolean
 	 wandle_in_Long_um=true 				
     If Not IsNumeric(eingabe) Then
         MsgBox ("Der von Ihnen eingegebene Wert mu eine Zahl sein! ")
         wandle_in_Long_um=False				
         Exit Function
     End If
     rueckgabe = CLng(eingabe)
 End Function
  
 Function berechnete_Tage(ByVal Monat As Long, ByVal Tage As Long) As Long
     Select Case Monat
         Case 1
             Tage = Tage
         Case 2
             Tage = 31 + Tage
         Case 3
             Tage = 31 + 28 + Tage
         Case 4
             Tage = 2 * 31 + 28 + Tage
         Case 5
             Tage = 2 * 31 + 28 + 30 + Tage
         Case 6
             Tage = 3 * 31 + 28 + 30 + Tage
         Case 7
             Tage = 3 * 31 + 28 + 2 * 30 + Tage
         Case 8
             Tage = 4 * 31 + 28 + 2 * 30 + Tage
         Case 9
             Tage = 5 * 31 + 28 + 2 * 30 + Tage
         Case 10
             Tage = 5 * 31 + 28 + 3 * 30 + Tage
         Case 11
             Tage = 6 * 31 + 28 + 3 * 30 + Tage
         Case 12
             Tage = 6 * 31 + 28 + 4 * 30 + Tage
     End Select
     berechnete_Tage = Tage
 End Function
 
 sub berechneFlugzeit(ByVal FlugdauerInSekunden As Long, _
 						FlugzeitStunden  As Long, _
 						FlugzeitTage  As Long, _
 						FlugzeitStunden As Long, _
 						FlugzeitMinuten As Long, _
 						FlugzeitSekunden As Long) 
 						
     FlugzeitStunden = FlugdauerInSekunden \ 3600
     FlugzeitTage = FlugzeitStunden \ 24
     FlugzeitStunden = FlugzeitStunden Mod 24
     FlugdauerInSekunden = FlugdauerInSekunden Mod 3600
     FlugzeitMinuten = FlugdauerInSekunden \ 60
     FlugzeitSekunden = FlugdauerInSekunden Mod 60
 end sub
