Attribute VB_Name = "Modul1"
 Option Explicit
 Sub privatkundenZinsberechnung()
 
 ' Programm berechnet die monatliche Belastung
 ' bei einzugebendem Kaufpreis und Eigenkapital
 ' Dateiname: privatkundenZinsberechnung
 ' Lsung mit Funktionen
 
     Dim eingabe As String
     Dim eigenkapital As Double
     Dim immobilienpreis As Double
     Dim monatlicheBelastung As Double
     Dim tilgung As Double
     Dim fehler As Boolean
     Dim neubauVerhalten As Boolean
     Dim beruecksichtigterPreis As Double
     
     MsgBox ("Bitte geben Sie das Eigenkapital und den " _
                 & "Kaufpreis des Kunden ein. Sie beenden das Programm, " _
                 & "indem Sie 'beenden' als Kaufpreis angeben.")
             
     eingabe = InputBox("Geben Sie jetzt den Kaufpreis des Kunden ein! ")
         
     Do While eingabe <> "beenden"
     
         If Not Lies_restliche_und_ueberpruefe_alle_Benutzereingaben(eingabe, _
             immobilienpreis, eigenkapital, tilgung, neubauVerhalten) Then Exit Sub
             
         If neubauVerhalten Then
             beruecksichtigterPreis = immobilienpreis * 0.8
         Else
             beruecksichtigterPreis = immobilienpreis
         End If
         
         monatlicheBelastung = monatliche_Belastung_berechnen(eigenkapital, immobilienpreis, _
                                        beruecksichtigterPreis, tilgung)
         ' Gib Ergebnisse aus
         MsgBox ("Ihre monatliche Belastung betrgt: " & monatlicheBelastung & " DM.")
         eingabe = InputBox("Geben Sie jetzt den Kaufpreis ein oder 'beenden'. ")
     Loop
 End Sub
 Function Lies_restliche_und_ueberpruefe_alle_Benutzereingaben(ByVal eingabe _
                     As String, immobilienpreis As Double, _
                     eigenkapital As Double, _
                     tilgung As Double, _
                     neubauVerhalten As Boolean) _
                     As Boolean
                                             
         Lies_restliche_und_ueberpruefe_alle_Benutzereingaben = True
         If Not wandle_in_Double_um(eingabe, immobilienpreis) Then
             Lies_restliche_und_ueberpruefe_alle_Benutzereingaben = False
             MsgBox ("Der Immobilienpreis muss eine Zahl sein!")
             Exit Function
         End If
                 
         eingabe = InputBox("Geben Sie nun das Eigenkapital des Kunden ein! ")
         If Not wandle_in_Double_um(eingabe, eigenkapital) Then
             Lies_restliche_und_ueberpruefe_alle_Benutzereingaben = False
             MsgBox ("Das Eigenkapital muss eine Zahl sein!")
             Exit Function
         End If
 
         eingabe = InputBox("Geben Sie nun die gewnschte Tilgung des Kunden ein! ")
         If Not wandle_in_Double_um(eingabe, tilgung) Then
             Lies_restliche_und_ueberpruefe_alle_Benutzereingaben = False
             MsgBox ("Die Tilgung muss eine Zahl sein!")
             Exit Function
         End If
 
         eingabe = InputBox("Neubauverhalten?" _
             & Chr$(13) & "Mgliche Eingaben: 'Ja', 'ja', 'Nein' und 'nein'.")
         Select Case eingabe
             Case "Ja", "ja"
                 neubauVerhalten = True
             Case "Nein", "nein"
                 neubauVerhalten = False
             Case Else
                 MsgBox ("Neubauverhalten mu Ja/ja oder Nein/nein sein!")
                 Lies_restliche_und_ueberpruefe_alle_Benutzereingaben = False
                 Exit Function
         End Select
 End Function
 
 Function wandle_in_Double_um(ByVal eingabe As String, rueckgabe As Double) _
                     As Boolean
     wandle_in_Double_um = True
     If Not IsNumeric(eingabe) Then
         MsgBox ("Der von Ihnen eingegebene Wert mu eine Zahl sein! ")
         wandle_in_Double_um = False
         Exit Function
     End If
     rueckgabe = CDbl(eingabe)
 End Function
Function monatliche_Belastung_berechnen(ByVal eigenkapital As Double, _
                     ByVal immobilienpreis As Double, _
                     ByVal beruecksichtigterPreis As Double, _
                     ByVal tilgung As Double) _
                     As Double
                                             
     Dim jahresBelastungZins As Double
     Dim jahresBelastungTilgung As Double
     Dim aufzunehmenderBetrag As Double
     
     Const zinsgrenze1 As Double = 0.6
     Const zinsgrenze2 As Double = 0.8
     Const zinsgrenze3 As Double = 1
     
     Const zinsBisZinsgrenze1 As Double = 6.25
     Const zinsZwischenZinsgrenze1UndZinsgrenze2 As Double = 7
     Const zinsZwischenZinsgrenze2UndZinsgrenze3 As Double = 7.5
     Const zinsUeberZinsgrenze3 As Double = 8.5
             
     aufzunehmenderBetrag = immobilienpreis - eigenkapital
         Select Case aufzunehmenderBetrag
             Case Is <= beruecksichtigterPreis * 0.6
                 jahresBelastungZins = (aufzunehmenderBetrag / 100) * zinsBisZinsgrenze1
             Case Is <= beruecksichtigterPreis * 0.8
                 jahresBelastungZins = (beruecksichtigterPreis * zinsgrenze1 / 100) * zinsBisZinsgrenze1 + _
                    ((aufzunehmenderBetrag - beruecksichtigterPreis * zinsgrenze1) / 100) * zinsZwischenZinsgrenze1UndZinsgrenze2
             Case Is <= beruecksichtigterPreis
                 jahresBelastungZins = ((beruecksichtigterPreis * zinsgrenze1) / 100) * zinsBisZinsgrenze1 + _
                    ((beruecksichtigterPreis * (zinsgrenze2 - zinsgrenze1)) / 100) * zinsZwischenZinsgrenze1UndZinsgrenze2 + _
                    ((aufzunehmenderBetrag - beruecksichtigterPreis * zinsgrenze2) / 100) * zinsZwischenZinsgrenze2UndZinsgrenze3
             Case Else
                 jahresBelastungZins = ((beruecksichtigterPreis * zinsgrenze1) / 100) * zinsBisZinsgrenze1 + _
                    ((beruecksichtigterPreis * (zinsgrenze2 - zinsgrenze1)) / 100) * zinsZwischenZinsgrenze1UndZinsgrenze2 + _
                    ((beruecksichtigterPreis * (zinsgrenze3 - zinsgrenze2)) / 100) * zinsZwischenZinsgrenze2UndZinsgrenze3 + _
                    ((aufzunehmenderBetrag - beruecksichtigterPreis) * zinsgrenze3 / 100) * (zinsUeberZinsgrenze3 + tilgung)
                 
         End Select
        jahresBelastungTilgung = (aufzunehmenderBetrag * tilgung) / 100
        monatliche_Belastung_berechnen = (jahresBelastungZins + jahresBelastungTilgung) / 12
 End Function


